/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.controler;

import java.io.IOException;
import javax.annotation.PostConstruct;
import javax.faces.FacesException;
import javax.faces.bean.ManagedBean;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 *
 * @author sebastien.glon
 */
@ManagedBean
public class Login {

    private String username = "";
    private String password = "";
    private boolean rememberMe = false;
    private boolean loggedIn = false;
    private String contextPath;

    @PostConstruct
    public void init() {
        contextPath = FacesContext.getCurrentInstance().getExternalContext().getRequestContextPath();
        username = "";
        password = "";
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return this.password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public boolean isLoggedIn() {
        return loggedIn;
    }

    public void setLoggedIn(boolean loggedIn) {
        this.loggedIn = loggedIn;
    }

    public boolean isRememberMe() {
        return rememberMe;
    }

    public void setRememberMe(boolean rememberMe) {
        this.rememberMe = rememberMe;
    }

    public String doLogin() throws IOException {
        FacesContext ctx = FacesContext.getCurrentInstance();

        ExternalContext extContext = ctx.getExternalContext();
        String url = extContext.encodeActionURL(contextPath
                + "/j_spring_security_check?j_username="
                + username + "&j_password=" + password);
        try {
            extContext.redirect(url);
            ctx.responseComplete();
        }
        catch (IOException ioe) {
            throw new FacesException(ioe);
        }
        return null;
    }

    public String doLogout() {
        FacesContext ctx = FacesContext.getCurrentInstance();

        ExternalContext extContext = ctx.getExternalContext();
        String url = extContext.encodeActionURL(contextPath
                + "/j_spring_security_logout");
        try {
            extContext.redirect(url);
        }
        catch (IOException ioe) {
            throw new FacesException(ioe);
        }
        return null;

    }
}
