/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.controler.admin;

import com.evasion.ejb.local.PartnershipManagerLocal;
import com.evasion.ejb.local.PersonManagerLocal;
import com.evasion.entity.Corporation;
import com.evasion.exception.PersistenceViolationException;
import com.evasion.entity.Partenaire;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;

/**
 *
 * @author sebastien.glon
 */
@ManagedBean()
@RequestScoped
public class FormPartenaire implements Serializable {

    private static final Logger LOG = Logger.getLogger(
            FormPartenaire.class.getName());
    @EJB
    private PartnershipManagerLocal ejb;
    @EJB
    private PersonManagerLocal ejbPerson;
    private Partenaire partenaire;
    private List<Corporation> corpoNotPart;
    private String fileLogo;

    @PostConstruct
    public void init() {
        LOG.log(Level.FINE, "Initialisation du ManagedBean");
        final FacesContext ctx = FacesContext.getCurrentInstance();
        partenaire = (Partenaire) ctx.getExternalContext().getSessionMap().get(AdminPartenaire.CURRENT_PARTENAIRE);
        if (partenaire.getId() == null) {
            corpoNotPart = ejb.listPotentialPartenaires();
            if (corpoNotPart.isEmpty()) {
                FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR,
                        "Vous devez d'abord créer des personnes morale", ""));
            } else {
                partenaire.setPerson(corpoNotPart.get(0));
            }
        }
    }

    @PreDestroy
    public void reset() {
    }

    public String valid() {
        String result = "Fail";
        try {
            if (fileLogo != null) {
                partenaire.getPerson().setLogo(fileLogo);
            }

            partenaire = ejb.savePartnership(partenaire);

            final FacesContext ctx = FacesContext.getCurrentInstance();
            ctx.getExternalContext().getSessionMap().remove(AdminPartenaire.CURRENT_PARTENAIRE);
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Les données ont été correctement sauvegardé", ""));
            result = "partenaireAdmin.xhtml";
        }
        catch (PersistenceViolationException ex) {
            LOG.log(Level.FINE, "Erreur de persistence", ex);
        }
        return result;
    }

    public String annul() {
        FacesContext ctx = FacesContext.getCurrentInstance();
        ctx.getExternalContext().getSessionMap().remove(AdminPartenaire.CURRENT_PARTENAIRE);
        return "partenaireAdmin.xhtml";
    }

    //----------- Getter Setter --------------------------//
    public List<Partenaire.Type> getTypes() {
        return Partenaire.Type.listValues();
    }

    public Partenaire.Type getType(String type) {
        return Partenaire.Type.valueOf(type);
    }

    public String getFileLogo() {
        return fileLogo;
    }

    public void setFileLogo(String fileLogo) {
        this.fileLogo = fileLogo;
    }

    public List<Corporation> getCorpoNotPart() {
        return corpoNotPart;
    }

    public void setCorpoNotPart(List<Corporation> corpoNotPart) {
        this.corpoNotPart = corpoNotPart;
    }

    public Partenaire getPartenaire() {
        return partenaire;
    }

    public void setPartenaire(Partenaire partenaire) {
        this.partenaire = partenaire;
    }

    public byte[] inputStreamToBytes(InputStream in) throws IOException {

        ByteArrayOutputStream out = new ByteArrayOutputStream(1024);
        byte[] buffer = new byte[1024];
        int len;

        while (( len = in.read(buffer) ) >= 0) {
            out.write(buffer, 0, len);
        }

        in.close();
        out.close();
        return out.toByteArray();
    }
}
