/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.controler.admin;

import com.evasion.common.Utils;
import com.evasion.entity.StaticPage;
import com.evasion.exception.PersistenceViolationException;
import com.evasion.ejb.local.StaticPageManagerLocal;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;

/**
 *
 * @author sebastien.glon
 */
@ManagedBean()
@RequestScoped
public class FormStaticPage {

    private static final Logger LOG = Logger.getLogger(FormStaticPage.class.getName());
    @EJB
    private StaticPageManagerLocal ejb;
    private com.evasion.entity.StaticPage pageStatic;

    @PostConstruct
    public void init() {
        FacesContext ctx = FacesContext.getCurrentInstance();
        pageStatic = (StaticPage) ctx.getExternalContext().getSessionMap().get("currentStaticPage");
    }

    @PreDestroy
    public void reset() {
    }

    public String validStaticPage() {

        try {
            if (pageStatic.getId() == null) {
                pageStatic.setUser(null);
                pageStatic = ejb.createPage(pageStatic, Utils.getUserName());
            } else {
                pageStatic = ejb.savePage(pageStatic);
            }
        }
        catch (PersistenceViolationException ex) {
            LOG.log(Level.SEVERE, null, ex);
        }
        if (pageStatic.getId() != null) {
            FacesContext ctx = FacesContext.getCurrentInstance();
            ctx.getExternalContext().getSessionMap().remove("currentStaticPage");
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Les données ont été correctement sauvegardé", ""));
            return "staticpageAdmin.xhtml";
        } else {
            return "Fail";
        }
    }

    public String annulStaticPage() {
        FacesContext ctx = FacesContext.getCurrentInstance();
        ctx.getExternalContext().getSessionMap().remove("currentStaticPage");
        return "staticpageAdmin.xhtml";
    }

    //----------- Getter Setter --------------------------//
    public StaticPage getPageStatic() {
        return pageStatic;
    }

    public void setPageStatic(StaticPage pageStatic) {
        this.pageStatic = pageStatic;
    }
}
