/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.controler.booktravel;

import com.evasion.common.Constante;
import com.evasion.common.Utils;
import com.evasion.ejb.local.BookTravelManagerLocal;
import com.evasion.ejb.local.ParametreManagerLocal;
import com.evasion.entity.booktravel.BookTravel;
import com.evasion.entity.booktravel.RoadMap;
import com.evasion.entity.booktravel.exception.BookTravelServiceException;
import java.util.List;
import java.util.Map;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author sebastien
 */
@ManagedBean
public class IndexBookTravel {

    /**
     * LOGGER.
     */
    private static final Logger LOGGER = LoggerFactory.getLogger(
            IndexBookTravel.class);
    @EJB
    ParametreManagerLocal paramEJB;
    @EJB
    BookTravelManagerLocal bookTravelEJB;
    private BookTravel bookTravel;
    private List<RoadMap> roadMaps;

    @PostConstruct
    public void init() {
        LOGGER.debug("Init de la page d'index d'un bookTravel");
        try {
            Map params = FacesContext.getCurrentInstance().
                    getExternalContext().getRequestParameterMap();
            String id = (String) params.get("id");
            if (Utils.isEmpty(id)) {
                id = paramEJB.getProperty(Constante.DEFAULT_BOOK_TRAVEL_ID);
            }
            this.bookTravel = bookTravelEJB.findBooktravelWithoutRoadMap(
                    Long.parseLong(id));
            this.roadMaps = bookTravelEJB.findNewestRoadMap( Long.parseLong(id), 5);
        }
        catch (BookTravelServiceException ex) {
            LOGGER.error("Le carnet de voyage demandé n'a pas été trouvé", ex);
        }
    }

    public BookTravel getBookTravel() {
        return bookTravel;
    }

    public void setBookTravel(BookTravel bookTravel) {
        this.bookTravel = bookTravel;
    }

    public List<RoadMap> getRoadMaps() {
        return roadMaps;
    }

    public void setRoadMaps(List<RoadMap> roadMap) {
        this.roadMaps = roadMap;
    }

}
